summaryrefslogtreecommitdiff
path: root/docs/diagrams
diff options
context:
space:
mode:
authorSandrine Bailleux <sandrine.bailleux@arm.com>2015-12-15 14:27:17 +0000
committerSandrine Bailleux <sandrine.bailleux@arm.com>2015-12-15 15:14:43 +0000
commitc2f0260c12e3d3c917a7242ef235832b6dbfd66d (patch)
tree6604b5bb9b4e92e8de893224f77a16776f61b8b1 /docs/diagrams
parent8e4f829179bf265e067c5e6151f044fdbdd298af (diff)
Introduce the ARM TF reset design document
This patch introduces a new document presenting the ARM Trusted Firmware Reset Design. It shows the reset code flow, lists the different build options that affect it, in which case to use them and what their exact effect is. The section about using BL31 entrypoint as the reset address has been moved from the general firmware design document to this one. It's also been improved to explain why the FVP port supports the RESET_TO_BL31 configuration, even though the reset vector address can't be programmed dynamically. This document includes some images, which have been generated using Dia version 0.97.2. This tool can be obtained from: https://wiki.gnome.org/Apps/Dia/Download This patch provides: - the image files describing the different reset flow diagrams; - the source '.dia' file; - a script automating the generation of the images from the '.dia' file. Note that the 2 latter files are not actually needed for the document and are provided for convenience only, in case the reset images need to be modified. Change-Id: Ib6302e8209d418a5b31c4e85e55fd9e83caf2ca2
Diffstat (limited to 'docs/diagrams')
-rw-r--r--docs/diagrams/default_reset_code.pngbin0 -> 60028 bytes
-rwxr-xr-xdocs/diagrams/generate_reset_images.sh41
-rw-r--r--docs/diagrams/reset_code_flow.diabin0 -> 4318 bytes
-rw-r--r--docs/diagrams/reset_code_no_boot_type_check.pngbin0 -> 59028 bytes
-rw-r--r--docs/diagrams/reset_code_no_checks.pngbin0 -> 51209 bytes
-rw-r--r--docs/diagrams/reset_code_no_cpu_check.pngbin0 -> 52471 bytes
6 files changed, 41 insertions, 0 deletions
diff --git a/docs/diagrams/default_reset_code.png b/docs/diagrams/default_reset_code.png
new file mode 100644
index 00000000..e7e0d855
--- /dev/null
+++ b/docs/diagrams/default_reset_code.png
Binary files differ
diff --git a/docs/diagrams/generate_reset_images.sh b/docs/diagrams/generate_reset_images.sh
new file mode 100755
index 00000000..eef5648d
--- /dev/null
+++ b/docs/diagrams/generate_reset_images.sh
@@ -0,0 +1,41 @@
+#! /bin/bash
+
+#
+# This script generates the image files used in the ARM Trusted Firmware Reset
+# Design document from the 'reset_code_flow.dia' file.
+#
+# The PNG files in the present directory have been generated using Dia version
+# 0.97.2, which can be obtained from https://wiki.gnome.org/Apps/Dia/Download
+#
+
+set -e
+
+# Usage: generate_image <layers> <image_filename>
+function generate_image
+{
+ dia \
+ --show-layers=$1 \
+ --filter=png \
+ --export=$2 \
+ reset_code_flow.dia
+
+}
+
+# The 'reset_code_flow.dia' file is organized in several layers.
+# Each image is generated by combining and exporting the appropriate set of
+# layers.
+generate_image \
+ Frontground,Background,cpu_type_check,boot_type_check \
+ default_reset_code.png
+
+generate_image \
+ Frontground,Background,no_cpu_type_check,boot_type_check \
+ reset_code_no_cpu_check.png
+
+generate_image \
+ Frontground,Background,cpu_type_check,no_boot_type_check \
+ reset_code_no_boot_type_check.png
+
+generate_image \
+ Frontground,Background,no_cpu_type_check,no_boot_type_check \
+ reset_code_no_checks.png
diff --git a/docs/diagrams/reset_code_flow.dia b/docs/diagrams/reset_code_flow.dia
new file mode 100644
index 00000000..5de00dad
--- /dev/null
+++ b/docs/diagrams/reset_code_flow.dia
Binary files differ
diff --git a/docs/diagrams/reset_code_no_boot_type_check.png b/docs/diagrams/reset_code_no_boot_type_check.png
new file mode 100644
index 00000000..8ce7e97a
--- /dev/null
+++ b/docs/diagrams/reset_code_no_boot_type_check.png
Binary files differ
diff --git a/docs/diagrams/reset_code_no_checks.png b/docs/diagrams/reset_code_no_checks.png
new file mode 100644
index 00000000..8a02f0f8
--- /dev/null
+++ b/docs/diagrams/reset_code_no_checks.png
Binary files differ
diff --git a/docs/diagrams/reset_code_no_cpu_check.png b/docs/diagrams/reset_code_no_cpu_check.png
new file mode 100644
index 00000000..8b05ea4d
--- /dev/null
+++ b/docs/diagrams/reset_code_no_cpu_check.png
Binary files differ